<vertex>

varying vec2 texCoord;
varying vec2 texCoord2;
//varying vec3 lightVec;
varying vec3 lightDir;
varying vec3 eyeDir; 
varying vec3 viewVec;
varying vec3 normal;
varying vec3 CubeTexCoord;

uniform vec3 lightPos;
uniform vec3 camPos;
uniform vec4 color;
uniform float invRadius;
uniform mat4 params;
uniform mat4 ModelWorld4x4;

//mat3 GetLinearPart( mat4 m )
//{
//	mat3 result;
	
//	result[0][0] = m[0][0]; 
//	result[0][1] = m[0][1]; 
//	result[0][2] = m[0][2]; 

//	result[1][0] = m[1][0]; 
//	result[1][1] = m[1][1]; 
//	result[1][2] = m[1][2]; 
	
//	result[2][0] = m[2][0]; 
//	result[2][1] = m[2][1]; 
//	result[2][2] = m[2][2]; 
	
//	return result;
//}	

void main() {
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

	texCoord = gl_MultiTexCoord0.xy;
	
	//vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	//vec3 binormal = cross(gl_MultiTexCoord3.xyz, gl_MultiTexCoord1.xyz);

	//vec3 lVec = lightPos - gl_Vertex.xyz;
	//lightDir = lVec;
	//lightVec.x = dot(gl_MultiTexCoord1.xyz, lVec); // TAN
	//lightVec.y = dot(gl_MultiTexCoord2.xyz, lVec); // Binormal - gl_MultiTexCoord2.xyz
	//lightVec.z = dot(gl_Normal.xyz, lVec); // Normal 

	vec3 vVec = camPos - gl_Vertex.xyz;
	viewVec.x = dot(gl_MultiTexCoord1.xyz, vVec);
	viewVec.y = dot(gl_MultiTexCoord2.xyz, vVec);
	viewVec.z = dot(gl_Normal.xyz, vVec);

	// sphere map texture coordinates
	//vec3 u = normalize( vec3(gl_ModelViewMatrix * gl_Vertex) );
	//vec3 n = normalize( gl_NormalMatrix * gl_Normal );
	//normal = normalize( gl_NormalMatrix * gl_Normal );
	//vec3 r = reflect( u, n );
	//float m = 2.0 * sqrt( r.x*r.x + r.y*r.y + (r.z+1.0)*(r.z+1.0) );
	//texCoord2.x = r.x/m + 0.5;
	//texCoord2.y = r.y/m + 0.5;


	//CubeTexCoord = vec3(gl_TextureMatrix[3] * gl_Vertex * gl_ModelViewProjectionMatrix );
	//CubeTexCoord = vec3(gl_TextureMatrix[3]  * gl_Vertex );
		
	mat3 ModelWorld3x3;// = GetLinearPart( ModelWorld4x4 );
	ModelWorld3x3[0][0] = ModelWorld4x4[0][0]; 
	ModelWorld3x3[0][1] = ModelWorld4x4[0][1]; 
	ModelWorld3x3[0][2] = ModelWorld4x4[0][2]; 

	ModelWorld3x3[1][0] = ModelWorld4x4[1][0]; 
	ModelWorld3x3[1][1] = ModelWorld4x4[1][1]; 
	ModelWorld3x3[1][2] = ModelWorld4x4[1][2]; 
	
	ModelWorld3x3[2][0] = ModelWorld4x4[2][0]; 
	ModelWorld3x3[2][1] = ModelWorld4x4[2][1]; 
	ModelWorld3x3[2][2] = ModelWorld4x4[2][2]; 

	// find world space position.
	vec4 WorldPos = ModelWorld4x4 *  gl_Vertex;	
	
	// find world space normal.
	normal = normalize( ModelWorld3x3 * gl_Normal ); 
	//normal = N;
	// find world space eye vector.
	eyeDir = normalize( WorldPos.xyz - camPos);	
	//eyeDir = E;// normalize( WorldPos.xyz  - vec3(camPos.x, camPos.y, camPos.z));

	lightDir = WorldPos.xyz - lightPos.xyz;

	// calculate the reflection vector in world space.
	CubeTexCoord = reflect( eyeDir, normal); 

	gl_FrontColor = color;
}

/*
 *
 */
<fragment>

uniform sampler2D s_texture_0; // Base
uniform sampler2D s_texture_1; // Bump
//uniform sampler2D s_texture_2; // Height map
uniform sampler2D s_texture_2; // Sphere map or Detail map
uniform samplerCube s_texture_3; // Cube map (environment)
uniform samplerCube s_texture_4; // Cube map 2 (soft box)

varying vec2 texCoord;
varying vec2 texCoord2;
//varying vec3 lightVec;
varying vec3 lightDir;
varying vec3 eyeDir; 
varying vec3 viewVec;
varying vec3 normal;
varying vec3 CubeTexCoord;

uniform float invRadius;
uniform mat4 params;


void main(){
	//float ambient = params[0].x; //0.1;//
	//float specularp = params[0].y;
	//float bCubeMap = params[1].y;

	// Parallax mapping
	//vec3 vVec = normalize(viewVec);
	//-float height = texture2D(s_texture_2, texCoord).x ;
	//vec2 newTexCoord = texCoord + ((height * 0.03 - 0.015) * (-vVec.xy));
	//-vec2 newTexCoord = texCoord + ((height * 0.04 - 0.02) * (-vVec.xy));
	
	//vec4 base = texture2D(s_texture_0, newTexCoord);
	//vec3 bump = normalize(texture2D(s_texture_1, newTexCoord).xyz * 2.0 - 1.0);

	vec4 base = texture2D(s_texture_0, texCoord);
	//vec3 bump = texture2D(s_texture_1, texCoord).xyz * 2.0 - 1.0;

	//bump = normalize(bump);

	//float distSqr = dot(lightVec, lightVec);
	//vec3 lVec = lightVec * inversesqrt(distSqr);

	//float atten = clamp(1.0 - invRadius / 10000.0 * sqrt(distSqr), 0.0, 1.0);
	
	//vec4 diffuse  = gl_Color * max(0.0, dot(lVec, normal)) * gl_LightSource[0].diffuse;
	//float diffuse = clamp(dot(lVec, bump), 0.0, 1.0);
	
	//float specular = pow(clamp(dot(reflect(normalize(-viewVec), bump), lVec), 0.0, 1.0), 16.0);

	//vec4 add = texture2D(s_texture_2, texCoord2);
	//vec4 det = texture2D(s_texture_2, texCoord * 40.0);

	//gl_FragColor = ambient * base + ((diffuse+0.2) * base + 0.3 * specular) * atten * gl_Color;
	//gl_FragColor = ambient * base * det + ((diffuse+0.2) * base + 0.3 * specular) * atten * gl_Color ;
	//if (bCubeMap > 0.0)
	//{
		vec4 cube_map = textureCube(s_texture_3, CubeTexCoord);
		//+vec4 cube_map = textureCube(s_texture_3, gl_TexCoord[1].xyz);
		//gl_FragColor = ambient *  base * 4.0 + (cube_map * 0.2) + (add * 0.2) * 0.5 * gl_Color;
		//gl_FragColor = ambient *  base * 4.0 + (cube_map * 0.2) + (0.3 * specular) * gl_Color;
		//gl_FragColor = cube_map  + ((diffuse+0.2) * base + specularp * specular) * atten * gl_Color;
		//+gl_FragColor = cube_map * gl_Color;
		
		// Perform a simple 2D texture look up.
		vec3 base_color = texture2D(s_texture_0, texCoord).rgb;
	
		// Perform a cube map look up.
		vec3 cube_color = textureCube(s_texture_3, CubeTexCoord).rgb;

		vec4 cube_color2 = textureCube(s_texture_4, CubeTexCoord);

		//gl_FragColor = vec4( mix(cube_color, base_color, 0.9), 1.0);

		vec3 L = normalize(lightDir);
		
		float lambertTerm = dot(normal,-L);
		vec4 final_color;
		
			final_color += lambertTerm;// * atten;	
		
			//vec3 E = eyeDir;
			//vec3 R = reflect(-L, normal);
		
			float specular = pow( max(dot(reflect(-L, normal), eyeDir), 0.0), 
			1.0);
		
			final_color +=  0.5 * specular;// * atten;	
		
		vec4 add = texture2D(s_texture_2, texCoord * 2.0);
	
		//gl_FragColor = (base + (cube_map * 1.5)) * ((final_color+0.5) * base)  * gl_Color;
		//gl_FragColor = ((final_color+0.2) * base)* atten + (base * (cube_map * 0.5))  * gl_Color;
		
		//gl_FragColor = ((final_color-0.2) * base) * atten + vec4( mix(cube_color, base_color, 0.7), 1.0) + (add * 0.1);

		//gl_FragColor = (((final_color / 3.0) - 0.5) * base) * atten +  vec4(mix(cube_color, base_color, 0.8), 1.0) + (cube_color2 * 0.8);
		// + (add * 0.1);
		gl_FragColor = (((final_color / 3.0) - 0.5) * base) + vec4(mix(cube_color, base_color, params[0].a), 1.0) + (cube_color2 * 0.8) + (add * 0.1);
		// for ati
		//gl_FragColor =(((final_color / 2.0)+0.5) * base) *  vec4(mix(cube_color, base_color, 0.9), 1.0) + (cube_color2 * 0.8) + (add * 0.1);



		//0.7
	//}
	//else
	//	gl_FragColor = ambient *  base * 4.0 + (add * 0.2) * 0.5 * gl_Color;

	//gl_FragColor = ambient * base + ((diffuse+0.2) * base) * gl_Color;
 //+ (add * 0.2
	
//
	
}